package xyz.brassgoggledcoders.boilerplate.blocks;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import xyz.brassgoggledcoders.boilerplate.IBoilerplateMod;
import xyz.brassgoggledcoders.boilerplate.IModAware;

import javax.annotation.Nonnull;

/**
 * @author Surseance
 *
 */
public class BlockBase extends Block implements IModAware
{
	IBoilerplateMod mod;

	public BlockBase(Material mat)
	{
		super(mat);
		this.func_149711_c(1F);
	}

	public BlockBase(Material mat, String name)
	{
		this(mat);
		this.setRegistryName(name);
		this.func_149663_c(name);
	}

	@Override
	public void func_180663_b(@Nonnull World world, @Nonnull BlockPos pos, @Nonnull IBlockState state)
	{
		world.func_175666_e(pos, this);

		super.func_180663_b(world, pos, state);
	}

	@Override
	public void func_176213_c(World worldIn, BlockPos pos, IBlockState state)
	{
		this.updateState(worldIn, pos, state);
	}

	@Override
	public void onNeighborChange(IBlockAccess world, BlockPos pos, BlockPos neighborPos)
	{
		this.updateState(world, pos, world.func_180495_p(neighborPos));
	}

	protected void updateState(IBlockAccess world, BlockPos pos, IBlockState state)
	{

	}

	@Override
	public IBoilerplateMod getMod()
	{
		return this.mod;
	}

	@Override
	public void setMod(IBoilerplateMod mod)
	{
		this.mod = mod;
	}
}
